Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 280616)
+++ channels/chan_sip.c	(working copy)
@@ -19180,12 +19180,17 @@
 		pvt_set_needdestroy(p, "received 481 response");
 		break;
 
+	case 482:   /* Loop Detected */
+	case 480:   /* Temporarily Unavailable */
+	case 404:   /* Not Found */
+	case 410:   /* Gone */
+	case 400:   /* Bad Request */
 	case 500:   /* Server error */
 	case 501:   /* Method not implemented */
 		/* Return to the current call onhold */
 		/* Status flag needed to be reset */
 		ast_log(LOG_NOTICE, "SIP transfer to %s failed, call miserably fails. \n", p->refer->refer_to);
-		pvt_set_needdestroy(p, "received 500/501 response");
+		pvt_set_needdestroy(p, "received 400, 404, 410, 480, 482, 500, or 501 response");
 		p->refer->status = REFER_FAILED;
 		if (p->owner) {
 			ast_queue_control_data(p->owner, AST_CONTROL_TRANSFER, &message, sizeof(message));
@@ -19199,6 +19204,16 @@
 			ast_queue_control_data(p->owner, AST_CONTROL_TRANSFER, &message, sizeof(message));
 		}
 		break;
+	default:
+		/* Return to the current call onhold */
+		/* Status flag needed to be reset */
+		ast_log(LOG_ERROR, "SIP transfer to %s failed, received unexpected response %d. \n", p->refer->refer_to, resp);
+		pvt_set_needdestroy(p, "received unexpected response");
+		p->refer->status = REFER_FAILED;
+		if (p->owner) {
+			ast_queue_control_data(p->owner, AST_CONTROL_TRANSFER, &message, sizeof(message));
+		}
+		break;
 	}
 }
 
